﻿#SAMPLE_RATE=44100
#FREQUENCY=1000
#BLOCK_SIZE=4000
#MAX_NUM=$7f;ff;  // максимальный short
 
; using namespace std;
;  
; LRESULT CALLBACK WinProc(HWND, UINT, WPARAM, LPARAM);
;  
; CHAR className[] = "main";
 
Global wave.l
Global hdr1.WAVEHDR
Global hdr2.WAVEHDR
Global iHdr = 1;
Global time = 0;
Global *data1=AllocateMemory(#BLOCK_SIZE)
Global *data2=AllocateMemory(#BLOCK_SIZE)
 
Procedure waveOutCallBack(hWave.l, msg.l, inst.l, param1.l, param2.l)
    If msg = #WOM_DONE
        If iHdr = 1
            For t = 0 To #BLOCK_SIZE-1
                PokeA(*data1+t,Int( Sin((time + t) * 2 * #PI * #FREQUENCY / #SAMPLE_RATE) * #MAX_NUM) ); // 2*PI
            Next t
            waveOutWrite_(hWave, @hdr1, SizeOf(WAVEHDR));
            iHdr = 2;
        Else
            For t = 0 To #BLOCK_SIZE-1
                PokeA(*data2+t, Int( Sin((time + t) * 2 * #PI * #FREQUENCY / #SAMPLE_RATE) * #MAX_NUM) ); // 2*PI
            Next t
            waveOutWrite_(hWave, @hdr2, SizeOf(WAVEHDR));
            iHdr = 1;
        EndIf
        time=time+#BLOCK_SIZE;
    EndIf
EndProcedure
 
;int main() {
    wForm.WAVEFORMATEX
    wForm\wFormatTag = #WAVE_FORMAT_PCM;
    wForm\nChannels = 1;
    wForm\nSamplesPerSec = #SAMPLE_RATE;
    wForm\wBitsPerSample = 16;
    wForm\nBlockAlign = wForm\nChannels * wForm\wBitsPerSample / 8;
    wForm\nAvgBytesPerSec = wForm\nSamplesPerSec * wForm\nBlockAlign;
    wForm\cbSize = 0
    waveOutOpen_(@wave, #WAVE_MAPPER, @wForm, @waveOutCallBack(), 0, #CALLBACK_FUNCTION| #WAVE_FORMAT_DIRECT);
 
    hdr1\lpData = *data1;
    hdr1\dwBufferLength = #BLOCK_SIZE ;SizeOf(short); // размер в байтах в два раза больше количества семплов
    ;//hdr1.dwFlags = 0;
 
    hdr2\lpData = *data2;
    hdr2\dwBufferLength = #BLOCK_SIZE ;SizeOf(short); // размер в байтах в два раза больше количества семплов
    ;//hdr2.dwFlags = 0;
 
    waveOutPrepareHeader_(wave, @hdr1, SizeOf(WAVEHDR));
    waveOutPrepareHeader_(wave, @hdr2, SizeOf(WAVEHDR));
 
    For t = 0 To #BLOCK_SIZE-1
      PokeA(*data1+t,Int( Sin((time + t) * 2 * #PI * #FREQUENCY / #SAMPLE_RATE) * #MAX_NUM) )
    Next t
    For t = 0 To #BLOCK_SIZE-1
PokeA(*data2+t,Int( Sin((time + t) * 2 * #PI * #FREQUENCY / #SAMPLE_RATE) * #MAX_NUM) )
    Next t
 
    iHdr = 1;
    time = time+#BLOCK_SIZE * 2;
    waveOutWrite_(wave, @hdr1, SizeOf(WAVEHDR));
    waveOutWrite_(wave, @hdr2, SizeOf(WAVEHDR));
 ;   Sleep_(4000);
 If OpenWindow(0, 0, 0, 230, 90, "Event handling example...", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)

   Repeat
     Event = WaitWindowEvent()
   Until Event = #PB_Event_CloseWindow
 EndIf

    waveOutUnprepareHeader_(wave, @hdr1, SizeOf(WAVEHDR));
    waveOutUnprepareHeader_(wave, @hdr2, SizeOf(WAVEHDR));
    waveOutClose_(wave);

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 76
; FirstLine = 45
; Folding = -
; EnableUnicode
; EnableXP