﻿#SAMPLE_RATE=44100
Global FREQUENCY.f=1000
#BLOCK_SIZE=4000
#MAX_NUM=$7fff;  // максимальный short

Enumeration
  #fsb
EndEnumeration

Global wave.l
Global hdr1.WAVEHDR
Global hdr2.WAVEHDR
Global iHdr = 1;
Global time = 0;
Global *data1=AllocateMemory(#BLOCK_SIZE*2)
Global *data2=AllocateMemory(#BLOCK_SIZE*2)

Procedure calcbuf(*d)
  For t = 0 To #BLOCK_SIZE-1
    PokeU(*d+t*2,Int( Sin((time + t) * 2 * #PI * FREQUENCY / #SAMPLE_RATE) * #MAX_NUM) ); // 2*PI
  Next t
EndProcedure

Procedure waveOutCallBack(hWave.l, msg.l, inst.l, param1.l, param2.l)
  If msg = #WOM_DONE
    If iHdr = 1
      calcbuf(*data1)
      waveOutWrite_(hWave, @hdr1, SizeOf(WAVEHDR));
      iHdr = 2                                    ;
    Else
      calcbuf(*data2)
      waveOutWrite_(hWave, @hdr2, SizeOf(WAVEHDR));
      iHdr = 1                                    ;
    EndIf
    time=time+#BLOCK_SIZE;
  EndIf
EndProcedure

Procedure freqback()
  
  FREQUENCY=GetGadgetState(#fsb);/15
  SetWindowTitle(0,Str(GetGadgetState(#fsb)))
EndProcedure

wForm.WAVEFORMATEX
wForm\wFormatTag = #WAVE_FORMAT_PCM;
wForm\nChannels = 1                ;
wForm\nSamplesPerSec = #SAMPLE_RATE;
wForm\wBitsPerSample = 16
wForm\nBlockAlign = wForm\nChannels * wForm\wBitsPerSample / 8;
wForm\nAvgBytesPerSec = wForm\nSamplesPerSec * wForm\nBlockAlign;
wForm\cbSize = 0
waveOutOpen_(@wave, #WAVE_MAPPER, @wForm, @waveOutCallBack(), 0, #CALLBACK_FUNCTION| #WAVE_FORMAT_DIRECT);

hdr1\lpData = *data1;
hdr1\dwBufferLength = #BLOCK_SIZE*2 ;SizeOf(short); // размер в байтах в два раза больше количества семплов

hdr2\lpData = *data2;
hdr2\dwBufferLength = #BLOCK_SIZE*2 ;SizeOf(short); // размер в байтах в два раза больше количества семплов

waveOutPrepareHeader_(wave, @hdr1, SizeOf(WAVEHDR));
waveOutPrepareHeader_(wave, @hdr2, SizeOf(WAVEHDR));

calcbuf(*data1)
calcbuf(*data2)
iHdr = 1;
time = time+#BLOCK_SIZE * 2;
waveOutWrite_(wave, @hdr1, SizeOf(WAVEHDR));
waveOutWrite_(wave, @hdr2, SizeOf(WAVEHDR));


If OpenWindow(0, 0, 0, 300, 90, "synth sinwave", #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  ScrollBarGadget(#fsb,0,10,290,20,221,8000,5)
  BindGadgetEvent(#fsb, @freqback())
  Repeat
    Event = WaitWindowEvent()
    Select Event
    EndSelect
    
  Until Event = #PB_Event_CloseWindow
EndIf

waveOutUnprepareHeader_(wave, @hdr1, SizeOf(WAVEHDR));
waveOutUnprepareHeader_(wave, @hdr2, SizeOf(WAVEHDR));
waveOutClose_(wave)                                  ;

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 19
; FirstLine = 15
; Folding = -
; EnableUnicode
; EnableXP